/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file isr.c
**
** 
**
**	History:
**		
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "cms80f261x.h"

/****************************************************************************/
/*	Local pre-processor symbols('#define')
****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
****************************************************************************/


/****************************************************************************/
/*	Local function prototypes('static')
****************************************************************************/


/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
****************************************************************************/


/******************************************************************************
 ** \brief	 INT0 interrupt service function
 **			
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void INT0_IRQHandler(void)  interrupt INT0_VECTOR
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 Timer 0 interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
******************************************************************************/
void Timer0_IRQHandler(void)  interrupt TMR0_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 INT0 interrupt service function
 **			
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void INT1_IRQHandler(void)  interrupt INT1_VECTOR
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 Timer 1 interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
******************************************************************************/
void Timer1_IRQHandler(void)  interrupt TMR1_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 UART 0 interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
******************************************************************************/
void UART0_IRQHandler(void)  interrupt UART0_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 Timer 2 interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
******************************************************************************/
void Timer2_IRQHandler(void)  interrupt TMR2_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 UART 1 interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
******************************************************************************/
void UART1_IRQHandler(void)  interrupt UART1_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 GPIO 0 interrupt service function
 **	
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void P0EI_IRQHandler(void)  interrupt P0EI_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 GPIO 1 interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void P1EI_IRQHandler(void)  interrupt P1EI_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	if(GPIO_GetIntFlag(GPIO1, GPIO_PIN_0))
	{
		P12=~P12;
		GPIO_ClearIntFlag(GPIO1, GPIO_PIN_0);
	}
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 GPIO 2 interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void P2EI_IRQHandler(void)  interrupt P2EI_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 GPIO 3 interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void P3EI_IRQHandler(void)  interrupt P3EI_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 GPIO 4 interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void P4EI_IRQHandler(void)  interrupt P4EI_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 GPIO 5 interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void P5EI_IRQHandler(void)  interrupt P5EI_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/********************************************************************************
 ** \brief	 ACMP interrupt service function
 **			
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void ACMP_IRQHandler(void)  interrupt ACMP_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 Timer 3 interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
******************************************************************************/
void Timer3_IRQHandler(void)  interrupt TMR3_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 Timer 4 interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
******************************************************************************/
void Timer4_IRQHandler(void)  interrupt TMR4_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 EPWM interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void EPWM_IRQHandler(void)  interrupt EPWM_VECTOR
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 ADC interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void ADC_IRQHandler(void)  interrupt ADC_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 WDT interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void WDT_IRQHandler(void)  interrupt WDT_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	I2C interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void I2C_IRQHandler(void)  interrupt I2C_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	SPI interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void SPI_IRQHandler(void)  interrupt SPI_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	UART2 interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void UART2_IRQHandler(void)  interrupt UART2_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	UART3 interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void UART3_IRQHandler(void)  interrupt UART3_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}

/******************************************************************************
 ** \brief	 LSE interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void LSE_IRQHandler(void)  interrupt LSE_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}
/******************************************************************************
 ** \brief	 LVD interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void LVD_IRQHandler(void)  interrupt LVD_VECTOR 
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}

/******************************************************************************
 ** \brief	 TOUCH interrupt service function
 **
 ** \param [in]  none   
 **
 ** \return none
 ******************************************************************************/
void TOUCH_IRQHandler(void)  interrupt TOUCH_VECTOR
{
	INTERRUPT_ENTER(); 		//жϷջ
	
	//û
	
	INTERRUPT_LEAVE();    //жϷջ
}








