/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file demo_uart.c
**
**  
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "demo_uart.h"

/****************************************************************************/
/*	Local pre-processor symbols('#define')
****************************************************************************/
#define  UARTx_BUAD_USE_BRT      1
#define  UARTx_BUAD_USE_BRT1     2
#define  UARTx_BUAD_USE_TMR1     3
#define  UARTx_BUAD_USE_TMR4     4
#define  UARTx_BUAD_USE_TMR2     5

#define  UARTx_BUAD_USE_SEL      UARTx_BUAD_USE_BRT

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
****************************************************************************/

/****************************************************************************/
/*	Local function prototypes('static')
****************************************************************************/

/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
****************************************************************************/
/******************************************************************************
 ** \brief	 UART1_Config
 ** \param [in] 
 **            	
 ** \return  none
 ** \note  
 ******************************************************************************/
void UART1_Config(void)
{

#if ( UARTx_BUAD_USE_BRT == UARTx_BUAD_USE_SEL)		//ʹBRTΪUARTģĲʱӷ
	 uint16_t  BRTValue = 0;
	 uint32_t  BaudRateVlue = 9600;
	 
	 /*
	 (1)UARTxģʽ
	 */
	 UART_ConfigRunMode(UART1,UART_MOD_ASY_8BIT, UART_BAUD_BRT);
	 UART_EnableReceive(UART1);
	 /*
	 (2)UARTxĲ
	 */
	 UART_ConfigBRTClk(BRT,BRT_CLK_DIV_1);	
	
	 UART_EnableDoubleFrequency(UART1); 							/*ʹܱƵSMOD =1*/
	
  #ifdef USE_FORMULA			//ʹùʽ㶨ʱļֵ(ҪSystemclockֵ(main.c))USE_FORMULA  ѡOption->C51->Preporcessor Symbols->Defineж
	 BRTValue = UART_ConfigBaudRate(UART1, BaudRateVlue) ;
  #else 
	 BRTValue = 65380; 				//ʹֲƼļֵ(BRT½),Ӧϵͳʱӣ24MHz
  #endif
 
	 UART_ConfigBRTPeriod(BRT,BRTValue);							/*װֵ*/
	 UART_EnableBRT(BRT);										/*ʹܶʱ*/
	 /*
	 (3)IO
	 */ 
	 GPIO_SET_MUX_MODE(P23CFG,GPIO_P23_MUX_TXD1);			/*TXD1*/
	 GPIO_SET_MUX_MODE(P22CFG,GPIO_P22_MUX_RXD1);	 		/*RXD1*/
	 GPIO_SET_PS_MODE( PS_RXD1, GPIO_UART1_RXD1_SEL_P22);	


#elif ( UARTx_BUAD_USE_BRT1 == UARTx_BUAD_USE_SEL)			//ʹBRT1ΪUARTģĲʱӷ
	 uint16_t  BRTValue = 0;
	 uint32_t  BaudRateVlue = 9600;
	 
	 /*
	 (1)UARTxģʽ
	 */
	 UART_ConfigRunMode(UART1,UART_MOD_ASY_8BIT, UART_BAUD_BRT1);
	 UART_EnableReceive(UART1);
	 /*
	 (2)UARTxĲ
	 */
	 UART_ConfigBRTClk(BRT1,BRT_CLK_DIV_1);	
	
	 UART_EnableDoubleFrequency(UART1); 							/*ʹܱƵSMOD =1*/

  #ifdef USE_FORMULA			//ʹùʽ㶨ʱļֵ(ҪSystemclockֵ(main.c))USE_FORMULA  ѡOption->C51->Preporcessor Symbols->Defineж
	 BRTValue = UART_ConfigBaudRate(UART1, BaudRateVlue) ;
  #else 
	 BRTValue = 65380; 				//ʹֲƼļֵ(BRT½),Ӧϵͳʱӣ24MHz
  #endif
 
	 UART_ConfigBRTPeriod(BRT1,BRTValue);						/*װֵ*/
	 UART_EnableBRT(BRT1);										/*ʹܶʱ*/
	 /*
	 (3)IO
	 */
	 GPIO_SET_MUX_MODE(P23CFG,GPIO_P23_MUX_TXD1);			/*TXD1*/
	 GPIO_SET_MUX_MODE(P22CFG,GPIO_P22_MUX_RXD1);	 		/*RXD1*/
	 GPIO_SET_PS_MODE( PS_RXD1, GPIO_UART1_RXD1_SEL_P22);	

	 
#elif ( UARTx_BUAD_USE_TMR1 == UARTx_BUAD_USE_SEL)		 //ʹTMR1ΪUARTģĲʱӷ

	 uint8_t  THxValue = 0;
	 uint32_t  BaudRateVlue = 9600;	 
	/*
	 (1)UARTxģʽ
	 */
	 UART_ConfigRunMode(UART1,UART_MOD_ASY_8BIT, UART_BAUD_TMR1);
	 UART_EnableReceive(UART1);
	/*
	 (2)UARTxĲ
	 */
	 TMR_ConfigTimerClk(TMR1,TMR_CLK_DIV_4);							/*TM =1*/
	 TMR_ConfigRunMode(TMR1, TMR_MODE_TIMING, TMR_TIM_AUTO_8BIT); 		/*Ϊ8λװģʽ*/
	
	 UART_EnableDoubleFrequency(UART1); 							/*ʹܱƵSMOD =1*/

  #ifdef USE_FORMULA			//ʹùʽ㶨ʱļֵ(ҪSystemclockֵ(main.c))USE_FORMULA  ѡOption->C51->Preporcessor Symbols->Defineж
	 THxValue = UART_ConfigBaudRate(UART1, BaudRateVlue) ;
  #else 
	 THxValue = 217; 				//ʹֲƼļֵ(UART½),Ӧϵͳʱӣ24MHz
  #endif
  
	 TMR_ConfigTimerPeriod(TMR1, THxValue, THxValue);			/*װֵ*/
	 TMR_Start(TMR1);											/*ʹܶʱ*/
	
	 /*
	 (3)IO
	 */
	 GPIO_SET_MUX_MODE(P23CFG,GPIO_P23_MUX_TXD1);			/*TXD1*/
	 GPIO_SET_MUX_MODE(P22CFG,GPIO_P22_MUX_RXD1);	 		/*RXD1*/
	 GPIO_SET_PS_MODE( PS_RXD1, GPIO_UART1_RXD1_SEL_P22);		

#elif ( UARTx_BUAD_USE_TMR4 == UARTx_BUAD_USE_SEL)	//ʹTMR4ΪUARTģĲʱӷ 

	 uint8_t  THxValue = 0;
	 uint32_t  BaudRateVlue = 9600;	 
	/*
	 (1)UARTxģʽ
	 */
	 UART_ConfigRunMode(UART1,UART_MOD_ASY_8BIT, UART_BAUD_TMR4);
	 UART_EnableReceive(UART1);
	/*
	 (2)UARTxĲ
	 */
	 TMR_ConfigTimerClk(TMR4,TMR_CLK_DIV_4);							/*TM =1*/
	 TMR_ConfigRunMode(TMR4, TMR_MODE_TIMING, TMR_TIM_AUTO_8BIT); 		/*Ϊ8λװģʽ*/
	
	 UART_EnableDoubleFrequency(UART1); 							/*ʹܱƵSMOD =1*/

  #ifdef USE_FORMULA			//ʹùʽ㶨ʱļֵ(ҪSystemclockֵ(main.c))USE_FORMULA  ѡOption->C51->Preporcessor Symbols->Defineж
	 THxValue = UART_ConfigBaudRate(UART1, BaudRateVlue) ;
  #else 
	 THxValue = 217; 				//ʹֲƼļֵ(UART½),Ӧϵͳʱӣ24MHz
  #endif
  
	 TMR_ConfigTimerPeriod(TMR4, THxValue, THxValue);			/*װֵ*/
	 TMR_Start(TMR4);											/*ʹܶʱ*/
	
	 /*
	 (3)IO
	 */
	 GPIO_SET_MUX_MODE(P23CFG,GPIO_P23_MUX_TXD1);			/*TXD1*/
	 GPIO_SET_MUX_MODE(P22CFG,GPIO_P22_MUX_RXD1);	 		/*RXD1*/
	 GPIO_SET_PS_MODE( PS_RXD1, GPIO_UART1_RXD1_SEL_P22);	


#elif ( UARTx_BUAD_USE_TMR2 == UARTx_BUAD_USE_SEL)		//ʹTMR2ΪUARTģĲʱӷ	 
	 uint16_t  TMR2Value = 0;
	 uint32_t  BaudRateVlue = 9600;	 
	/*
	 (1)UARTxģʽ
	 */
	 UART_ConfigRunMode(UART1,UART_MOD_ASY_8BIT, UART_BAUD_TMR2);
	 UART_EnableReceive(UART1);
	/*
	 (2)UARTxĲ
	 */
	 TMR2_ConfigTimerClk(TMR2_CLK_DIV_12);						/*T2PS =0*/
	 TMR2_ConfigRunMode(TMR2_MODE_TIMING, TMR2_AUTO_LOAD); 		/*Ϊ8λװģʽ*/
	
	 UART_EnableDoubleFrequency(UART1); 							/*ʹܱƵSMOD =1*/

  #ifdef USE_FORMULA				//ʹùʽ㶨ʱļֵ(ҪSystemclockֵ(main.c))USE_FORMULA  ѡOption->C51->Preporcessor Symbols->Defineж
	 TMR2Value = UART_ConfigBaudRate(UART1, BaudRateVlue) ;
														//ҪĲʼֵٸݼֵƳʵʵĲʣʽڲοֲ"ʼ"½ڣ
														//ƫϴӰͨѶ뻻һȸߵĲʣ
  #else 
	 TMR2Value = 65523; 			//ݲοֲĹʽӦϵͳʱӣ24MHz				
  #endif
  
	 TMR2_ConfigTimerPeriod(TMR2Value);						/*װֵ*/
	 TMR2_Start();											/*ʹܶʱ*/
	
	 /*
	 (3)IO
	 */
	 GPIO_SET_MUX_MODE(P23CFG,GPIO_P23_MUX_TXD1);			/*TXD1*/
	 GPIO_SET_MUX_MODE(P22CFG,GPIO_P22_MUX_RXD1);	 		/*RXD1*/
	 GPIO_SET_PS_MODE( PS_RXD1, GPIO_UART1_RXD1_SEL_P22);		
#endif




}



/******************************************************************************
 ** \brief	 putchar
 ** \param [in] data
 **            	
 ** \return  none
 ** \note   <stdio.h>Ҫĺ
 ******************************************************************************/
char putchar (char ch)
{
	SBUF1 = ch;
	while( !(SCON1 & (1<<1)));
	SCON1 &=~(1<<1);		
	return 0;
}

/******************************************************************************
 ** \brief	 putchar
 ** \param [in] none
 **            	
 ** \return  data
 ** \note   <stdio.h>Ҫĺ
 ******************************************************************************/
char getchar (void)
{
	while(!(SCON1 & (1<<0)));
	SCON1 &=~(1<<0);
	return  SBUF1;	
}
/********************************************************************************
 ** \brief	 puts 
 **
 ** \param [in]  bytes addr for sending
 **
 ** \return  <stdio.h>Ҫĺ
 ******************************************************************************/
int  puts( const char  * s)
{
	while(*s)
	{
		putchar(*s);
		s++;
	}

	return 0;
}






