/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, 21F, Building T1, Qianhai Financial Center, No.91 Guiwan 3rd Road, 
* Qianhai Shenzhen-Hong Kong Cooperation Zone, Shenzhen City , Guangdong Province,
* P R China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/*****************************************************************************/
/** \file gpio.h
**
** 
**
** History:
** 
*****************************************************************************/
#ifndef __GPIO_H__
#define __GPIO_H__
/*****************************************************************************/
/* Include files */
/*****************************************************************************/
#include "cms80f261x.h"
/*****************************************************************************/
/* Global pre-processor symbols/macros ('#define') */
/*****************************************************************************/
/*----------------------------------------------------------------------------
 **GPIO
 ---------------------------------------------------------------------------*/
#define  GPIO_PIN_0_MSK				(0x01)		/* GPIO Pin 0 mask */
#define  GPIO_PIN_1_MSK				(0x02)		/* GPIO Pin 1 mask */
#define  GPIO_PIN_2_MSK				(0x04)		/* GPIO Pin 2 mask */
#define  GPIO_PIN_3_MSK				(0x08)		/* GPIO Pin 3 mask */
#define  GPIO_PIN_4_MSK				(0x10)		/* GPIO Pin 4 mask */
#define  GPIO_PIN_5_MSK				(0x20)		/* GPIO Pin 5 mask */
#define  GPIO_PIN_6_MSK				(0x40)		/* GPIO Pin 6 mask */
#define  GPIO_PIN_7_MSK				(0x80)		/* GPIO Pin 7 mask */

#define  GPIO_PIN_0					(0x00)		/* GPIO Pin 0 number*/
#define  GPIO_PIN_1					(0x01)		/* GPIO Pin 1 number */
#define  GPIO_PIN_2					(0x02)		/* GPIO Pin 2 number */
#define  GPIO_PIN_3					(0x03)		/* GPIO Pin 3 number */
#define  GPIO_PIN_4					(0x04)		/* GPIO Pin 4 number */
#define  GPIO_PIN_5					(0x05)		/* GPIO Pin 5 number */
#define  GPIO_PIN_6					(0x06)		/* GPIO Pin 6 number */
#define  GPIO_PIN_7					(0x07)		/* GPIO Pin 7 number */

#define  GPIO0						(0x00)
#define  GPIO1						(0x01)
#define  GPIO2						(0x02)
#define  GPIO3						(0x03)
#define  GPIO4						(0x04)
#define  GPIO5						(0x05)

#define  GPIO_P00					(0x00)
#define  GPIO_P01					(0x01)
#define  GPIO_P02					(0x02)
#define  GPIO_P03					(0x03)
#define  GPIO_P04					(0x04)
#define  GPIO_P05					(0x05)
#define  GPIO_P06					(0x06)
#define  GPIO_P07					(0x07)

#define  GPIO_P10					(0x10)
#define  GPIO_P11					(0x11)
#define  GPIO_P12					(0x12)
#define  GPIO_P13					(0x13)
#define  GPIO_P14					(0x14)
#define  GPIO_P15					(0x15)
#define  GPIO_P16					(0x16)
#define  GPIO_P17					(0x17)

#define  GPIO_P20					(0x20)
#define  GPIO_P21					(0x21)
#define  GPIO_P22					(0x22)
#define  GPIO_P23					(0x23)
#define  GPIO_P24					(0x24)
#define  GPIO_P25					(0x25)
#define  GPIO_P26					(0x26)
#define  GPIO_P27					(0x27)

#define  GPIO_P30					(0x30)
#define  GPIO_P31					(0x31)
#define  GPIO_P32					(0x32)
#define  GPIO_P33					(0x33)
#define  GPIO_P34					(0x34)
#define  GPIO_P35					(0x35)
#define  GPIO_P36					(0x36)
#define  GPIO_P37					(0x37)

#define  GPIO_P40					(0x40)
#define  GPIO_P41					(0x41)
#define  GPIO_P42					(0x42)
#define  GPIO_P43					(0x43)
#define  GPIO_P44					(0x44)
#define  GPIO_P45					(0x45)
#define  GPIO_P46					(0x46)
#define  GPIO_P47					(0x47)

#define  GPIO_P50					(0x50)
#define  GPIO_P51					(0x51)
#define  GPIO_P52					(0x52)
#define  GPIO_P53					(0x53)
#define  GPIO_P54					(0x54)
#define  GPIO_P55					(0x55)

/*----------------------------------------------------------------------------
 ** IOŸģʽ
---------------------------------------------------------------------------*/
#define  GPIO_MUX_GPIO		(0x00)			/*GPIO*/
/*--GPIOֹ---------------------------------------------------------*/
/*--Timer2Ƚͨ-----------------------------------------------*/
#define  GPIO_P16_MUX_CC0	(0x06)			
#define  GPIO_P45_MUX_CC0	(0x06)
#define  GPIO_P17_MUX_CC1	(0x06)
#define  GPIO_P02_MUX_CC2	(0x06)
#define  GPIO_P55_MUX_CC3	(0x06)
/*--ͨ-----------------------------------------------------*/
#define  GPIO_P20_MUX_BUZZ	(0x06)
#define  GPIO_P53_MUX_BUZZ	(0x06)
/*--Ƚͨ-----------------------------------------------------*/
#define  GPIO_P03_MUX_C0O	(0x06)			/*Ƚ0*/
#define  GPIO_P06_MUX_C0O	(0x06)
#define  GPIO_P37_MUX_C0O	(0x06)
#define  GPIO_P46_MUX_C0O	(0x06)
#define  GPIO_P05_MUX_C1O	(0x06)			/*Ƚ1*/
#define  GPIO_P50_MUX_C1O	(0x06)
/*--ͨ-------------------------------------------------------------*/
#define  GPIO_P20_MUX_RXD0	(0x02)
#define  GPIO_P21_MUX_TXD0	(0x02)

#define  GPIO_P11_MUX_RXD1	(0x02)
#define  GPIO_P14_MUX_RXD1	(0x02)
#define  GPIO_P22_MUX_RXD1	(0x02)
#define  GPIO_P13_MUX_TXD1	(0x02)
#define  GPIO_P23_MUX_TXD1	(0x02)

#define  GPIO_P05_MUX_TXD2	(0x02)
#define  GPIO_P06_MUX_RXD2	(0x02)

#define  GPIO_P44_MUX_TXD3	(0x02)
#define  GPIO_P45_MUX_RXD3	(0x02)
/*--SPIͨ-------------------------------------------------------------*/
#define  GPIO_P04_MUX_SCLK	(0x03)
#define  GPIO_P12_MUX_SCLK	(0x03)
#define  GPIO_P24_MUX_SCLK	(0x03)
#define  GPIO_P43_MUX_SCLK	(0x03)

#define  GPIO_P05_MUX_MOSI	(0x03)
#define  GPIO_P13_MUX_MOSI	(0x03)
#define  GPIO_P22_MUX_MOSI	(0x03)
#define  GPIO_P44_MUX_MOSI	(0x03)

#define  GPIO_P06_MUX_MISO	(0x03)
#define  GPIO_P11_MUX_MISO	(0x03)
#define  GPIO_P14_MUX_MISO	(0x03)
#define  GPIO_P23_MUX_MISO	(0x03)
#define  GPIO_P45_MUX_MISO	(0x03)

#define  GPIO_P07_MUX_NSS	(0x03)
#define  GPIO_P15_MUX_NSS	(0x03)
#define  GPIO_P25_MUX_NSS	(0x03)
#define  GPIO_P31_MUX_NSS	(0x03)
#define  GPIO_P47_MUX_NSS	(0x03)

#define  GPIO_P07_MUX_NSSO0	(0x03)
#define  GPIO_P15_MUX_NSSO1	(0x03)
#define  GPIO_P25_MUX_NSSO2	(0x03)
#define  GPIO_P31_MUX_NSSO3	(0x03)
#define  GPIO_P47_MUX_NSSO3	(0x03)

/*--I2Cͨ----------------------------------------------------------*/
#define  GPIO_P04_MUX_SCL	(0x04)
#define  GPIO_P12_MUX_SCL	(0x04)
#define  GPIO_P14_MUX_SCL	(0x04)
#define  GPIO_P43_MUX_SCL	(0x04)
#define  GPIO_P45_MUX_SCL	(0x04)

#define  GPIO_P05_MUX_SDA	(0x04)
#define  GPIO_P13_MUX_SDA	(0x04)
#define  GPIO_P44_MUX_SDA	(0x04)
/*--EPWMͨ----------------------------------------------------------*/
#define  GPIO_P03_MUX_PG0	(0x05)
#define  GPIO_P22_MUX_PG0	(0x05)
#define  GPIO_P30_MUX_PG0	(0x05)
#define  GPIO_P40_MUX_PG0	(0x05)
#define  GPIO_P50_MUX_PG0	(0x05)

#define  GPIO_P02_MUX_PG1	(0x05)
#define  GPIO_P21_MUX_PG1	(0x05)
#define  GPIO_P31_MUX_PG1	(0x05)
#define  GPIO_P41_MUX_PG1	(0x05)
#define  GPIO_P51_MUX_PG1	(0x05)

#define  GPIO_P01_MUX_PG2	(0x05)
#define  GPIO_P24_MUX_PG2	(0x05)
#define  GPIO_P32_MUX_PG2	(0x05)
#define  GPIO_P42_MUX_PG2	(0x05)

#define  GPIO_P00_MUX_PG3	(0x05)
#define  GPIO_P23_MUX_PG3	(0x05)
#define  GPIO_P33_MUX_PG3	(0x05)
#define  GPIO_P43_MUX_PG3	(0x05)

#define  GPIO_P05_MUX_PG4	(0x05)
#define  GPIO_P27_MUX_PG4	(0x05)
#define  GPIO_P34_MUX_PG4	(0x05)
#define  GPIO_P44_MUX_PG4	(0x05)
#define  GPIO_P52_MUX_PG4	(0x05)

#define  GPIO_P04_MUX_PG5	(0x05)
#define  GPIO_P26_MUX_PG5	(0x05)
#define  GPIO_P35_MUX_PG5	(0x05)
#define  GPIO_P45_MUX_PG5	(0x05)
#define  GPIO_P53_MUX_PG5	(0x05)

#define  GPIO_P25_MUX_FB0	(0x05)
#define  GPIO_P46_MUX_FB1	(0x05)

/*--Timer2ֻͨPS_CAPnĴֵ--------------------------------*/
#define  GPIO_P04_MUX_CAP0	(0x04)		/*PS_CAP0Ĵ*/
#define  GPIO_P27_MUX_CAP1	(0x27)		/*PS_CAP1Ĵ*/
#define  GPIO_P30_MUX_CAP2	(0x30)		/*PS_CAP2Ĵ*/
#define  GPIO_P47_MUX_CAP3	(0x47)		/*PS_CAP3Ĵ*/

/*--Timer0ſ루ֻPS_T0GĴֵ--------------------------------*/
#define  GPIO_P01_MUX_T0G	(0x01)
#define  GPIO_P52_MUX_T0G	(0x52)
/*--Timer0ⲿʱ루ֻPS_T0Ĵֵ----------------------------*/
#define  GPIO_P02_MUX_T0	(0x02)
#define  GPIO_P53_MUX_T0	(0x53)

/*--Timer1ſ루ֻPS_T1GĴֵ--------------------------------*/
#define  GPIO_P00_MUX_T1G	(0x00)
#define  GPIO_P17_MUX_T1G	(0x17)
#define  GPIO_P55_MUX_T1G	(0x55)
/*--Timer1ⲿʱ루ֻPS_T1Ĵֵ----------------------------*/
#define  GPIO_P03_MUX_T1	(0x03)
#define  GPIO_P20_MUX_T1	(0x20)
#define  GPIO_P54_MUX_T1	(0x54)

/*--Timer2 ⲿ루ֻPS_T2EXĴֵ--------------------------*/
#define  GPIO_P04_MUX_T2EX	(0x04)
/*--Timer2ⲿſ루ֻPS_T2Ĵֵ-----------------------*/
#define  GPIO_P05_MUX_T2	(0x05)
/*--ADC ӲţֻPS_ADETĴֵ-----------------------------*/
#define  GPIO_P00_MUX_ADET	(0x00)
#define  GPIO_P10_MUX_ADET	(0x10)
#define  GPIO_P20_MUX_ADET	(0x20)
#define  GPIO_P30_MUX_ADET	(0x30)
#define  GPIO_P40_MUX_ADET	(0x40)
#define  GPIO_P50_MUX_ADET	(0x50)

/*--SPIʱӶ˿ڷ䣨ֻPS_SCLKĴֵ(ӻģʽ)-----------------------------*/
#define  GPIO_SPI_SCLK_SEL_P04	(0x04)
#define  GPIO_SPI_SCLK_SEL_P12	(0x12)
#define  GPIO_SPI_SCLK_SEL_P24	(0x24)
#define  GPIO_SPI_SCLK_SEL_P43	(0x43)
/*--SPI MOSI˿ڷ䣨ֻPS_MOSIĴֵ(ӻģʽ)-----------------------------*/
#define  GPIO_SPI_MOSI_SEL_P05	(0x05)
#define  GPIO_SPI_MOSI_SEL_P13	(0x13)
#define  GPIO_SPI_MOSI_SEL_P22	(0x22)
#define  GPIO_SPI_MOSI_SEL_P44	(0x44)

/*--SPI MISO˿ڷ䣨ֻPS_MISOĴֵ(ģʽ)-----------------------------*/
#define  GPIO_SPI_MISO_SEL_P06	(0x06)
#define  GPIO_SPI_MISO_SEL_P14	(0x14)
#define  GPIO_SPI_MISO_SEL_P23	(0x23)
#define  GPIO_SPI_MISO_SEL_P45	(0x45)
/*--SPI NSS˿ڷ䣨ֻPS_NSSĴֵ(ӻģʽ)-----------------------------*/
#define  GPIO_SPI_NSS_SEL_P07	(0x07)
#define  GPIO_SPI_NSS_SEL_P15	(0x15)
#define  GPIO_SPI_NSS_SEL_P25	(0x25)
#define  GPIO_SPI_NSS_SEL_P31	(0x31)
#define  GPIO_SPI_NSS_SEL_P47	(0x47)

/*--I2C SCL˿ڷ䣨ֻPS_SCLĴֵ(ӻģʽ)-----------------------------*/
#define  GPIO_I2C_SCL_SEL_P04	(0x04)
#define  GPIO_I2C_SCL_SEL_P12	(0x12)
#define  GPIO_I2C_SCL_SEL_P14	(0x14)
#define  GPIO_I2C_SCL_SEL_P43	(0x43)
#define  GPIO_I2C_SCL_SEL_P45	(0x45)
/*--I2C SDA˿ڷ䣨ֻPS_SDAĴֵ(ӻģʽ)-----------------------------*/
#define  GPIO_I2C_SDA_SEL_P05	(0x05)
#define  GPIO_I2C_SDA_SEL_P13	(0x13)
#define  GPIO_I2C_SDA_SEL_P44	(0x44)

/*--UART1 RXD1˿ڷ䣨ֻPS_RXD1Ĵֵ-----------------------------*/
#define  GPIO_UART1_RXD1_SEL_P11	(0x11)
#define  GPIO_UART1_RXD1_SEL_P14	(0x14)
#define  GPIO_UART1_RXD1_SEL_P22	(0x22)


/*--ANALOG--------------------------------------------------------------*/
#define  GPIO_MUX_ANA		(0x01)			/*ģ⹦(GPIOֹܹر)*/
/*----ADCͨ-----------------------------------------------------------*/
#define  GPIO_P14_MUX_AN0	(0x01)
#define  GPIO_P15_MUX_AN1	(0x01)
#define  GPIO_P16_MUX_AN2	(0x01)
#define  GPIO_P17_MUX_AN3	(0x01)
#define  GPIO_P20_MUX_AN4	(0x01)
#define  GPIO_P21_MUX_AN5	(0x01)
#define  GPIO_P22_MUX_AN6	(0x01)
#define  GPIO_P23_MUX_AN7	(0x01)
#define  GPIO_P34_MUX_AN8	(0x01)
#define  GPIO_P35_MUX_AN9	(0x01)
#define  GPIO_P36_MUX_AN10	(0x01)
#define  GPIO_P37_MUX_AN11	(0x01)
#define  GPIO_P40_MUX_AN12	(0x01)
#define  GPIO_P41_MUX_AN13	(0x01)
#define  GPIO_P42_MUX_AN14	(0x01)
#define  GPIO_P43_MUX_AN15	(0x01)
#define  GPIO_P44_MUX_AN16	(0x01)
#define  GPIO_P12_MUX_AN17	(0x01)
#define  GPIO_P13_MUX_AN18	(0x01)
#define  GPIO_P24_MUX_AN19	(0x01)
#define  GPIO_P25_MUX_AN20	(0x01)
#define  GPIO_P26_MUX_AN21	(0x01)
#define  GPIO_P27_MUX_AN22	(0x01)

/*----ACMPͨ-----------------------------------------------------------*/
#define  GPIO_P04_MUX_C0P0	(0x01)
#define  GPIO_P40_MUX_C0P4	(0x01)
#define  GPIO_P41_MUX_C0P5	(0x01)
#define  GPIO_P42_MUX_C0P6	(0x01)
#define  GPIO_P43_MUX_C0P7	(0x01)
#define  GPIO_P05_MUX_C0N0	(0x01)
#define  GPIO_P44_MUX_C0N1	(0x01)

#define  GPIO_P06_MUX_C1P0	(0x01)
#define  GPIO_P07_MUX_C1N	(0x01)

/*----OPAͨ-----------------------------------------------------------*/
#define  GPIO_P53_MUX_OP0O	(0x01)
#define  GPIO_P50_MUX_OP0P	(0x01)
#define  GPIO_P51_MUX_OP0N	(0x01)

#define  GPIO_P47_MUX_OP1O	(0x01)
#define  GPIO_P54_MUX_OP1P	(0x01)
#define  GPIO_P55_MUX_OP1N	(0x01)










/********************************************************************************
 ** \brief	 GPIO_SET_MUX_MODE
 **			 IOڵĸù
 ** \param [in] PorttCFG IOڵĸüĴ P00CFG.....
 **            PinMode IOڵĸù 
 ** \return  none
********************************************************************************/
#define  GPIO_SET_MUX_MODE(PortCFG,PinMode)		(PortCFG = PinMode)	

/********************************************************************************
 ** \brief	 GPIO_SET_PS_MODE
 **			 ö˿빦ܷ
 ** \param [in]  Ps_modePS_INT0PS_INT1..... PS_RXD1
 **				 gpio:	(1)GPIO_P00 .... GPIO_P55
 **						(2)GPIO_P04_MUX_CAP0....GPIO_P50_MUX_ADET
 **						(3)GPIO_SPI_SCLK_SEL_P04....GPIO_UART1_RXD1_SEL_P22
 ** \return  none
********************************************************************************/
#define  GPIO_SET_PS_MODE(Ps_mode,gpio)		(Ps_mode = gpio)	


/********************************************************************************
 ** \brief	 GPIO_ENABLE_OUTPUT
 **			 ʹGPIOΪģʽ
 ** \param [in] PortTRIS Ĵ P0TRIS P1TRIS P2TRIS P3TRISP4TRIS P5TRIS  
 **            PinNumGPIO_PIN_0...GPIO_PIN_7
 ** \return  none
 ******************************************************************************/
#define	 GPIO_ENABLE_OUTPUT(PortTRIS, PinNum)	(PortTRIS |= (1<<PinNum))

/********************************************************************************
 ** \brief	 GPIO_ENABLE_INPUT
 **			 ʹGPIOΪ̬ģʽ
 ** \param [in] PortRIS Ĵ P0TRIS P1TRIS P2TRIS P3TRISP4TRIS P5TRIS 
 **            PinNumGPIO_PIN_0...GPIO_PIN_7
 ** \return  none
 ******************************************************************************/
#define  GPIO_ENABLE_INPUT(PortTRIS, PinNum)	(PortTRIS &= ~(1<<PinNum))

/********************************************************************************
 ** \brief	 GPIO_ENABLE_OD
 **			 GPIO©ܿ
 ** \param [in] PortOD  :©ܼĴP0ODP1ODP2ODP3ODP4ODP5OD
 **            PinNumGPIO_PIN_0...GPIO_PIN_7
 ** \return  none
 ******************************************************************************/
#define  GPIO_ENABLE_OD(PortOD, PinNum)			(PortOD |= (1<<PinNum))
/********************************************************************************
 ** \brief	 GPIO_DISABLE_OD
 **			 GPIO©ܹر
 ** \param [in] PortOD  :©ܼĴP0ODP1ODP2ODP3ODP4ODP5OD
 **            PinNumGPIO_PIN_0...GPIO_PIN_7
 ** \return  none
 ******************************************************************************/
#define  GPIO_DISABLE_OD(PortOD, PinNum)		(PortOD &= ~(1<<PinNum))
/********************************************************************************
 ** \brief	 GPIO_ENABLE_UP
 **			 GPIOܿ
 ** \param [in] PortUP  :ܼĴP0UPP1UPP2UPP3UPP4UPP5UP
 **            PinNumGPIO_PIN_0...GPIO_PIN_7
 ** \return  none
 ******************************************************************************/
#define  GPIO_ENABLE_UP(PortUP, PinNum)			(PortUP |= (1<<PinNum))
/********************************************************************************
 ** \brief	 GPIO_DISABLE_UP
 **			 GPIOܹر
 ** \param [in] PortUP  :ܼĴP0UPP1UPP2UPP3UPP4UPP5UP
 **            PinNumGPIO_PIN_0...GPIO_PIN_7
 ** \return  none
 ******************************************************************************/
#define  GPIO_DISABLE_UP(PortUP, PinNum)		(PortUP &= ~(1<<PinNum))
/********************************************************************************
 ** \brief	 GPIO_ENABLE_RD
 **			 GPIOܿ
 ** \param [in] PortRD  :ܼĴP0RDP1RDP2RDP3RDP4RDP5RD
 **            PinNumGPIO_PIN_0...GPIO_PIN_7
 ** \return  none
 ******************************************************************************/
#define  GPIO_ENABLE_RD(PortRD, PinNum)			(PortRD |= (1<<PinNum))
/********************************************************************************
 ** \brief	 GPIO_DISABLE_RD
 **			 GPIOܹر
 ** \param [in] PortRD  :ܼĴP0RDP1RDP2RDP3RDP4RDP5RD
 **            PinNumGPIO_PIN_0...GPIO_PIN_7
 ** \return  none
 ******************************************************************************/
#define  GPIO_DISABLE_RD(PortRD, PinNum)		(PortRD &= ~(1<<PinNum))

/********************************************************************************
 ** \brief	 GPIO_ENABLE_SLOW_SLOPE
 **			 GPIOбʹܿ
 ** \param [in] PortSR  :бʿƹܼĴP0SRP1SRP2SRP3SRP4SRP5SR
 **            PinNumGPIO_PIN_0...GPIO_PIN_7
 ** \return  none
 ******************************************************************************/
#define  GPIO_ENABLE_SLOW_SLOPE(PortSR, PinNum)      (PortSR |= (1<<PinNum))
/********************************************************************************
 ** \brief	 GPIO_ENABLE_FAST_SLOPE
 **			 GPIO бʹܿ
 ** \param [in] PortSR  :бʿƹܼĴP0SRP1SRP2SRP3SRP4SRP5SR
 **            PinNumGPIO_PIN_0...GPIO_PIN_7
 ** \return  none
 ******************************************************************************/
#define  GPIO_ENABLE_FAST_SLOPE(PortSR, PinNum)     (PortSR &= ~(1<<PinNum))

/********************************************************************************
 ** \brief	 GPIO_SET_PXDS
 **			 GPIO_PxDSĴλ
 ** \param [in] PortDS  :ѡĴP0DSP1DSPD2SP3DSP4DSP5DS
 **            PinNumGPIO_PIN_0...GPIO_PIN_7
 ** \return  none
 ******************************************************************************/
#define GPIO_SET_PXDS(PortDS, PinNum)			(PortDS |= (1<<PinNum))

/********************************************************************************
 ** \brief	 GPIO_CLR_PXDS
			GPIO_PxDSĴ
 ** \param [in] PortDS  :ѡĴP0DSP1DSPD2SP3DSP4DSP5DS
 **            PinNumGPIO_PIN_0...GPIO_PIN_7
 ** \return  none
 ******************************************************************************/
#define GPIO_CLR_PXDS(PortDS, PinNum)			(PortDS &= ~(1<<PinNum))


/*----------------------------------------------------------------------------
 **GPIO жϴģʽ
/*---------------------------------------------------------------------------*/
#define  GPIO_INT_RISING	(0x01)			/*شж*/
#define  GPIO_INT_FALLING	(0x02)			/*½شж*/
#define  GPIO_INT_BOTH_EDGE	(0x03)			/*½ؾж*/

/********************************************************************************
 ** \brief	 GPIO_SET_INT_MODE
 **			 IOڵⲿжϹ
 ** \param [in] PorttEICFG IOڵⲿжģʽüĴ
 **            PinIntMode IOڵĸù 
 ** \return  none
 ******************************************************************************/
#define  GPIO_SET_INT_MODE(PortEICFG, PinIntMode)	(PortEICFG = PinIntMode)

/********************************************************************************
 ** \brief	 GPIO_ENABLE_INT_MODE
 **			ʹIOڵⲿжϹ
 ** \param [in] PorttEXTIE IOڵⲿжϼĴ
 **            PinMSKGPIO_PIN_0_MSK .. GPIO_PIN_7_MSK
 ** \return  none
 ******************************************************************************/
#define  GPIO_ENABLE_INT_MODE(PortEXTIE,PinMSK)		(PortEXTIE |= PinMSK)	

/********************************************************************************
 ** \brief	 GPIO_DISABLE_INT_MODE
 **			رIOڵⲿжϹ
 ** \param [in] PorttEXTIE IOڵⲿжϼĴ
 **            PinMSK: GPIO_PIN_0_MSK .. GPIO_PIN_7_MSK
 ** \return  none
 ******************************************************************************/
#define  GPIO_DISABLE_INT_MODE(PortEXTIE,PinMSK)	(PortEXTIE &= ~PinMSK)	

/*****************************************************************************/
/* Global type definitions ('typedef') */
/*****************************************************************************/


/*****************************************************************************/
/* Global variable declarations ('extern', definition in C source) */
/*****************************************************************************/

/*****************************************************************************/
/* Global function prototypes ('extern', definition in C source) */
/*****************************************************************************/

 /********************************************************************************
 ** \brief	 GPIO_EnableInt
 **			 ʹIOڵжϹ
 ** \param [in] Port   GPIO0GPIO1GPIO2GPIO3GPIO4GPIO5
 **			    PinMSK: GPIO_PIN_0_MSK ~ GPIO_PIN_7_MSK			 
 ** \return  none
 ** \note   
 ******************************************************************************/
void GPIO_EnableInt(uint8_t Port, uint8_t PinMSK);
/********************************************************************************
 ** \brief	 GPIO_DisableInt
 **			 رIOڵжϹ
 ** \param [in] Port   GPIO0GPIO1GPIO2GPIO3GPIO4GPIO5
 **			    PinMSK: GPIO_PIN_0_MSK ~ GPIO_PIN_7_MSK			 
 ** \return  none
 ** \note   
 ******************************************************************************/
void GPIO_DisableInt(uint8_t Port, uint8_t PinMSK);

 /******************************************************************************
 ** \brief	 GPIO_GetIntFlag
 **			 ȡжϱ־
 ** \param [in] Port   GPIO0GPIO1GPIO2GPIO3GPIO4GPIO5
 **			    PinNum:  GPIO_PIN_0~GPIO_PIN_7 		 
 ** \return  0жϲ
 **			 1жϲ
 ** \note  
 ******************************************************************************/
uint8_t  GPIO_GetIntFlag(uint8_t Port, uint8_t PinNum);
 /********************************************************************************
 ** \brief	 GPIO_ClearIntFlag
 **			жϱ־λ
 ** \param [in] Port   GPIO0GPIO1GPIO2GPIO3GPIO4GPIO5
 **			    PinNum:  GPIO_PIN_0~GPIO_PIN_7 		 
 ** \return  none
 ** \note  
 ******************************************************************************/
void GPIO_ClearIntFlag(uint8_t Port, uint8_t PinNum);

#endif /* __GPIO_H__ */






